////////////////////////////////////////////////////////////////////////////////
//
//  ****************************************************************************
//  * Project   : Fangorn Wizards Lab Exstension Library v1.35
//  * Unit Name : FWOpenDirectoryReg
//  * Purpose   :        .
//  * Author    :  (Rouse_) 
//  * Copyright :  Fangorn Wizards Lab 1998 - 2011.
//  * Version   : 1.00
//  ****************************************************************************
//

unit FWOpenDirectoryReg;

interface

uses
  Windows, Classes, SysUtils,
  {$IFDEF VER130}
    DsgnIntf
  {$ELSE}
    DesignIntf, DesignEditors, VCLEditors
  {$ENDIF};

type
  //    About
  TAboutPropertyEditor = class(TStringProperty)
    function GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
  end;

  //   RootDir  StartDir
  TSelectDirPropertyEditor = class(TStringProperty)
    function GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
  end;

  //     
  TFWOpenDirectoryEditor = class(TComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

procedure Register;

implementation

uses FWOpenDirectory;

procedure Register;
begin
  RegisterComponents('Fangorn Wizards Lab', [TFWOpenDirectory]);
  RegisterPropertyEditor(TypeInfo(String), TFWOpenDirectory, 'About', TAboutPropertyEditor);
  RegisterPropertyEditor(TypeInfo(WideString), TFWOpenDirectory, 'RootDir', TSelectDirPropertyEditor);
  RegisterPropertyEditor(TypeInfo(String), TFWOpenDirectory, 'StartDir', TSelectDirPropertyEditor);
  RegisterComponentEditor(TFWOpenDirectory, TFWOpenDirectoryEditor);
end;

{ TAboutPropertyEditor }

procedure TAboutPropertyEditor.Edit;
begin
  inherited;
  MessageBoxEx(GetDesktopWindow, PChar('Fangorn Wizards Lab Exstension Library v1.35'+#13#10+
    ' Fangorn Wizards Lab 1998-2011'+#13#10+
    'Author: Alexander (Rouse_) Bagel'+#13#10+
    'Mailto: rouse79@yandex.ru'), 'About...',  MB_ICONASTERISK, LANG_NEUTRAL);
end;

function TAboutPropertyEditor.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paDialog];
end;

{ TSelectDirPropertyEditor }

procedure TSelectDirPropertyEditor.Edit;
var
  Dialog: TFWOpenDirectory;
begin
  inherited;
  Dialog := TFWOpenDirectory.Create(nil);
  try
    if Dialog.Execute then
      SetValue(Dialog.DirName);
  finally
    Dialog.Free;
  end;
end;

function TSelectDirPropertyEditor.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paDialog];
end;

{ TFWOpenDirectoryEditor }

procedure TFWOpenDirectoryEditor.ExecuteVerb(Index: Integer);
var
  Dialog: TFWOpenDirectory;
begin
  inherited;
  Dialog := (Component as TFWOpenDirectory);
  Dialog.Execute;
end;

function TFWOpenDirectoryEditor.GetVerb(Index: Integer): string;
begin
  Result := 'Test Dialog';
end;

function TFWOpenDirectoryEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

end.
